'***********************************************************
'PREMERE IL TASTO-FUNZIONE "F5" PER FAR PARTIRE IL PROGRAMMA
'***********************************************************
CLS
PI = 3.141592654#
PRINT ""
PRINT ""
PRINT ""
PRINT ""
PRINT ""
PRINT "     ************   PROGRAMMI PER L' ORIENTAMENTO   ************"
PRINT ""
PRINT "                     Autore: Dr.Enrico Maddalena"
PRINT "     Piazza Torlonia, 49/D - 67051 AVEZZANO AQ - tel.0863/26620 "
PRINT ""
PRINT ""
PRINT "     Questo programma  abbinato a:"
PRINT ""
PRINT "     O R I E N T E E R I N G :"
PRINT "     Orientamento e topografia per escursioni, alpinismo, trekking"
PRINT ""
PRINT "     Ulrico Hoepli Editore - Via U. Hoepli, 5 -  20121 MILANO   "
PRINT "     Telefono: 02/86487.1 - 733.142 - 70126381 - 738.5383"
PRINT ""
PRINT ""
PRINT "* Premere un tasto per continuare * "
A$ = INPUT$(1)
CLS
PRINT ""
PRINT ""
PRINT ""
PRINT ""
PRINT " **************************     Informazioni     ***************************"
PRINT ""
PRINT ""
PRINT "Per declinazione magnetica si intende l' angolo fra il meridiano geografico"
PRINT "ed il meridiano magnetico. Si considera positiva se il nord magnetico  alla"
PRINT "destra del nord geografico (declinazione orientale)."
PRINT ""
PRINT "Per variazione magnetica si intende l' angolo fra il meridiano magnetico"
PRINT "ed il reticolato chilometrico. Si considera positiva se il nord magnetico"
PRINT " alla destra del nord rete (variazione orientale)."
PRINT ""
PRINT "* Premere un tasto per continuare * "
A$ = INPUT$(1)

CLS
PRINT ""
PRINT ""
PRINT ""
PRINT ""
PRINT "*********************        MENU DEL PROGRAMMA        **********************"
PRINT ""
PRINT "(1) COSTRUZIONE DI SCALIMETRI"
PRINT "(2) CONVERSIONE METRI/DOPPI-PASSI"
PRINT "(3) CALCOLO DI AZIMUT E DISTANZA"
PRINT "(4) INTERSEZIONE INDIETRO"
PRINT "(5) PUNTO DI STAZIONE, NOTI TRE PUNTI"
PRINT ""
INPUT "MENU (digitare il numero relativo all' argomento del menu.(Uscita=0)) --->  ", MENU
IF MENU = 0 THEN END
IF MENU = 1 THEN GOTO 100
IF MENU = 2 THEN GOTO 200
IF MENU = 3 THEN GOTO 300
IF MENU = 4 THEN GOTO 400
IF MENU = 5 THEN GOTO 500
100 CLS
PRINT "      ********** COSTRUZIONE DI SCALIMETRI ***********"
PRINT ""
PRINT ""
INPUT "Graduati in metri o doppi-passi (M/D)"; MD$
PRINT ""
INPUT "Scala della carta (inserire solo il denominatore, es. 15000)"; SC
PRINT ""
INPUT "Lunghezza dello scalimetro da graduare (cm)"; LS
PRINT ""
LS = LS * 10
IF MD$ = "D" THEN GOTO 150
110 INPUT "Intervallo (in metri sul terreno) della graduazione"; D1
PRINT ""
120 MM = D * 1000 / SC
IF MM > LS THEN BEEP
IF MM > LS THEN PRINT "Sei giunto alla fine dello scalimetro"
PRINT ""
PRINT D; "metri sul terreno, corrispondono a"; MM; "mm sulla carta"
D = D + D1
PRINT ""
INPUT "ANCORA (NO=N;SI=INVIO)"; SN$
IF SN$ = "N" THEN END ELSE GOTO 120
150 PRINT ""
INPUT "Doppi passi in 100 metri"; DP
PRINT ""
160 INPUT "Intervallo (in doppi-passi sul terreno) della graduazione"; PD1
PRINT ""
170 MM = PD * 100000 / (DP * SC)
MM = INT(MM * 10 + .5) / 10
IF MM > LS THEN BEEP
IF MM > LS THEN PRINT "Sei giunto alla fine dello scalimetro!"
PRINT ""
PRINT PD; "doppi-passi sul terreno, corrispondono a"; MM; "mm sulla carta"
PRINT ""
PD = PD + PD1
INPUT "ANCORA (NO=N;SI=INVIO)"; SN$
IF SN$ = "N" THEN END ELSE GOTO 170
200 CLS
PRINT "       ********** CONVERSIONE METRI/DOPPI PASSI *********"
PRINT ""
PRINT ""
INPUT "Doppi passi in 100 metri"; DP
PRINT ""
INPUT "Da metri a doppi-passi (1) o da doppi- passi a metri (2)"; MD$
PRINT ""
IF MD$ = "2" THEN GOTO 250
210 INPUT "Metri da convertire in doppi-passi"; M
PRINT ""
PD = M * DP / 100
PRINT M; "metri, corrispondono a"; PD; "doppi passi"
PRINT ""
INPUT "ANCORA (S/N)"; SN$
IF SN$ = "N" THEN END ELSE GOTO 210
250 CLS
INPUT "Doppi passi da convertire in metri"; PD
PRINT ""
M = PD * 100 / DP
PRINT PD; "doppi passi, corrispondono a"; M; "metri"
PRINT ""
INPUT "ANCORA (S/N)"; SN$
IF SN$ = "N" THEN END ELSE GOTO 250
300 CLS
PRINT "***** CALCOLO DI AZIMUT E DISTANZA, DATE LE COORDINATE DEI DUE PUNTI *****"
PRINT ""
PRINT ""
PRINT "Se la Variazione (o decl.ne) magnetica  orientale, +V; se  occidentale, -V"
PRINT ""
INPUT " Valore della variazione (o declinazione) magnetica"; DV
PRINT ""
INPUT "Doppi-passi per coprire 100 metri"; DP
PRINT ""
PRINT ""
310 INPUT "Coordinate di A (Xa)"; XA
INPUT "Coordinate di A (Ya)"; YA
INPUT "Coordinate di B (Xb)"; XB
INPUT "Coordinate di B (Yb)"; YB
DX = (XB - XA): DY = (YB - YA)
FI = ABS(ATN(DX / DY)) * 180 / PI
AB = 10 * INT(ABS(SQR((DX ^ 2) + DY ^ 2)))
DP1 = INT((DP * AB / 100) + .5)
IF DX > 0 AND DY > 0 THEN GOTO 350
IF DX > 0 AND DY < 0 THEN FI = 180 - FI
IF DX < 0 AND DY < 0 THEN FI = 180 + FI
IF DX < 0 AND DY > 0 THEN FI = 360 - FI
PRINT ""
350 PRINT "Azimut"; INT((FI - DV) * 10 + .5) / 10; "gradi"
PRINT "Distanza"; AB; "metri, pari a"; DP1; "doppi-passi"
PRINT ""
PRINT "ANCORA (S/N)"; SN$
IF SN$ = "S" THEN END ELSE GOTO 310
400 CLS
PRINT "            ********** INTERSEZIONE INDIETRO **********"
PRINT ""
PRINT ""
PRINT "Se la Variazione (o decl.ne) magnetica  orientale, +V; se  occidentale, -V"
PRINT ""
INPUT " Valore della variazione (o declinazione) magnetica"; DV
DV = DV * PI / 180
410 PRINT ""
INPUT "Coordinate di A (Xa)"; XA
INPUT "Coordinate di A (Ya)"; YA
INPUT "Coordinate di B (Xb)"; XB
INPUT "Coordinate di B (Yb)"; YB
PRINT ""
INPUT "Azimut di A da C(punto di stazione)"; FIA
FIA = FIA * PI / 180
INPUT "Azimut di B da C(punto di stazione)"; FIB
FIB = FIB * PI / 180
DEN = 1 / TAN(FIA + DV) - 1 / TAN(FIB + DV)
XC = (XA * (1 / TAN(FIA + DV)) - XB * (1 / TAN(FIB + DV)) + YB - YA) / DEN
YC = XC * (1 / TAN(FIB + DV)) - (1 / TAN(FIB + DV)) * XB + YB
PRINT ""
PRINT "Le coordinate del punto di stazione sono:"
PRINT "Xc="; INT(XC + .5)
PRINT "Yc="; INT(YC + .5)
INPUT "ANCORA (S/N)"; SN$
IF SN$ = "N" THEN END ELSE GOTO 410
500 CLS
PRINT ""
PRINT ""
PRINT "***************  COORDINATE DEL PUNTO DI STAZIONE  ***************"
PRINT "      NOTE LE COORDINATE E GLI AZIMUT DI 3 PUNTI NOTEVOLI "
PRINT ""
PRINT ""
510 INPUT "Ascissa di A (Xa)"; XA
INPUT "Ordinata di A (Ya)"; YA
INPUT "Ascissa di B (Xb)"; XB
INPUT "Ordinata di B (Yb)"; YB
INPUT "Ascissa di C (Xc)"; XC
INPUT "Ordinata di C (Yc)"; YC
PRINT ""
INPUT "Azimut di A da P(punto di stazione)"; FIA
FIA = FIA * PI / 180
INPUT "Azimut di B da P(punto di stazione)"; FIB
FIB = FIB * PI / 180
INPUT "Azimut di C da P(punto di stazione)"; FIC
FIC = FIC * PI / 180
FCB = FIC - FIB: FBA = FIB - FIA: CBA = 1 / TAN(FBA): CCB = 1 / TAN(FCB): CCA = 1 / TAN(FIC - FIA)
DEN = ((((YB - YA) * CBA) - ((YC - YA) * CCA)) - XC + XB)
QW = ((((XB - XA) * CBA) - ((XC - XA) * CCA)) + YC - YB) / DEN
QE = TAN((ATN(QW)) + FBA)
YP = ((-(QE * (YB - YA)) + XB - XA) / (QW - QE)) + YA
XP = (YP - YA) * QW + XA
PRINT ""
PRINT "Ascissa del punto di stazione:"; CLNG(XP)
PRINT "Ordinata del punto di stazione:"; CLNG(YP)
PRINT ""
INPUT "ANCORA (S/N)"; SN$
IF SN$ = "S" THEN GOTO 510 ELSE END



